/* FILE: randRainbow.cpp   last change: 14-Sept-2012   author: Romeo Rizzi
 * generates a sequence of n random integers in the interval [0..MAX_VAL].
 * Usage syntax:
 *   > randRainbow out_file n MAX_VAL seed
 */

#include <iostream>
#include <fstream>
#include <cstdlib>
#include <ctime>

using namespace std;

int RandNumber(int min, int max) {
  /* returns an integer in [min, max]
   * see Stroustrup "The c++ Programming Language" 3th edition pg. 685
   * for comments on the following manipulation choice.
   * In particular, considerations on the bad quality of low bits come into account.
   */
 return min + (int) ( (max-min) * (double(rand()) / RAND_MAX) );
}

int main(int argc, char** argv) {
  srand(time(NULL));
  int n, MAX_VAL = 255;
  n = atoi(argv[2]);
  if(argc > 3) MAX_VAL = atoi(argv[3]);
  if(argc > 4) srand( atoi(argv[4]) );

  ofstream fout(argv[1]);
  fout << n << endl;
  for(int i = 1; i <= n; i++)
    fout <<  RandNumber(0, MAX_VAL) << " ";
  fout << endl;
  fout.close();
  return 0;
}
